package pack;

import java.awt.image.RenderedImage;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.data.general.DefaultPieDataset;


@WebServlet(name = "grafico", urlPatterns = {"/grafico"})
public class grafico extends HttpServlet {

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("image/png");
        try (ServletOutputStream os = response.getOutputStream()) {
          
            DefaultPieDataset dataset = new DefaultPieDataset();
            
            int l1 = Integer.parseInt(request.getParameter("votiList1"));
            int l2 = Integer.parseInt(request.getParameter("votiList2"));
            int l3 = Integer.parseInt(request.getParameter("votiList3"));
            int l4 = Integer.parseInt(request.getParameter("votiList4"));
            int l5 = Integer.parseInt(request.getParameter("votiList5"));
            
            dataset.setValue("Lista 1, voti: "+l1, l1);
            dataset.setValue("Lista 2, voti: "+l2, l2);
            dataset.setValue("Lista 3, voti: "+l3, l3);
            dataset.setValue("Lista 4, voti: "+l4, l4);
            dataset.setValue("Lista 5, voti: "+l5, l5);
            
            JFreeChart chart = ChartFactory.createPieChart("Grafico Liste Scolastiche", dataset);
                    
            RenderedImage chartImage = chart.createBufferedImage(700, 700);
            ImageIO.write(chartImage, "png", os);
            os.flush();
            os.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
